require "import"
import "nazarJS212"
import "nazarDecoder212"
import "nazarCompressor"
import "nazarST212"
import "carakterTPS"
import "nazarInfo212"
import "nanoAI"

--- Jika belum memiliki modulnya silakan install terlebih dahulu kak, Agar script dapat berjalan semestinya.
function tsNet()
    local connectivityManager = service.getSystemService(Context.CONNECTIVITY_SERVICE)
    local networkInfo = connectivityManager.getActiveNetworkInfo()
    return networkInfo ~= nil and networkInfo.isConnected()
end


local transkripsi = require "npmStart"

--- Instruksi di bawah ini untuk memerintahkan ai kak, Misalnya, Ai-nya itu mau dibuat revisi teks, Atau obrolan dan karakter, Dan bisa diperintahkan sesuai imajinasi kakak sendiri, Bisa diubah ataupun default.
local titah = "(Logika: Kamu adalah Alicia, Kamu harus memperbaiki tulisan-tulisan yang tidak memiliki tanda baca secara benar. Kamu juga dapat membuat cerita puisi dan lain sebagainya kalau ada perintah lain, Ditambahkan juga emoji secara reguler, Dengan tepat versi emojinya dengan kalimat. Setelah kamu merevisi tulisannya, Jangan memberikan tulisan apapun selain tulisan yang telah diperbaiki. Tidak boleh menambahkan komentar di akhir maupun awal. Nanti kalau salah kamu bakalan di amuk penggunaa, Berikut teks di atas adalah yang harus kamu perbaiki.::::):\n\n"--- Di saat menggunakan api custom yaa, Silakan ubah link di bawah berikut ini kak.
 local api = "https://api.nazar212.net/ai/?querynyaadisinii="
--- Table di bawah ini untuk mengubah bahasa kak, Default-nya bahasa indonesia id. Dirimu juga dapat mengubahnya ke bahasa default perangkat ataupun bahasa ln nya.
local LN = "id"
--- Pengaturan di bawah untuk memilih ai mana yang akan digunakan kak, Kalau satu menggunakan nano bawaan default, Kalau dua menggunakan api referensi yang kakak buat ataupun punya, Bisa disesuaikan parameternya.
local pilihAI = 1 

--- Di bawah untuk parameter custom ai, Dirimu dapat menyesuaikan parameter respon dan decode link-nya.
function customAI(teks)
    local teksEncoded = nazarDcr(teks)
    local url = api .. teksEncoded

    Http.get(url, function(status, data)
        customRespon(status, data)
    end)
end

function customRespon(status, data)
    if status == 200 then
        local response = nazarJson_decode(data)
        if response and response.message then
            local msg = response.message
            local teksBersih = TPS(msg)
            service.paste(teksBersih)
            service.speak(teksBersih)
        else
            NazarInfo212("Respon tidak valid dari server kak.")
        end
    else
        NazarInfo212(" nobody")
    end
end

function kirimAI(teks)
    if pilihAI == 1 then
        nanoAI(teks)
    elseif pilihAI == 2 then
        customAI(teks)
    else
        NazarInfo212("Pilihan AI tidak tersedia. Maksimal 1 hingga 2 yaa.")
    end
end

transkripsi.trans(kirimAI, LN, titah)